;Cybot test program - Nigel Goodwin Oct 2001


RHFor		equ	01
LHFor		equ	03
RHBak		equ	00
LHBak		equ	02
Ser_In          Equ     04	;bit position for RS232 in
Ser_Out		Equ	07	;bit position for RS232 out

d1		equ	20
d2		equ	21
del		equ	22
Bit_Cntr        Equ     23	;bit counter for RS232
Xmit_Byte       Equ     24	;holds byte to xmit
Rcv_Byte	Equ	25	;holds received byte
Delay_Count	Equ	26	;delay variable for RS232
Key		Equ	27	;holds key pressed

	LIST	p=16C84 , r=dec
	include "P16C84.inc"
	__config H'3FF9' 


;=====================================================

;Macros

page1		macro
		bsf	STATUS,RP0
		endm

page0		macro
		bcf	STATUS,RP0
		endm


; Time delay macro, call wait [number of seconds] - max 25.5 seconds

wait	macro	variable
	movlw	variable * 0x0a
	call	Delay

	endm

wait2	macro	variable
	movlw	variable
	call	Delay2

	endm

;=====================================================

	org	0000
	goto 	start
	org	0004

; Subroutines

; call 100mS delay number of times in W
Delay	movwf	del
DelLoop	call 	Del100
	decfsz	del, f
	goto	DelLoop
	return

; 100mS delay
Del100	movlw	0x8d
	movwf	d1
Delay_00
	movlw	0xeb
	movwf	d2
Delay_01
	decfsz	d2, f
	goto	Delay_01
	decfsz	d1, f
	goto	Delay_00

			;25 cycles
	movlw	0x08
	movwf	d1
Delay_10
	decfsz	d1, f
	goto	Delay_10

			;1 cycles
	nop

			;4 cycles (including call)
	return

; call bit_delay number of times in W
Delay2	movwf	del
Loop1	call 	Bit_Delay
	decfsz	del, f
	goto	Loop1
	return

Xmit_RS232      MOVWF   Xmit_Byte            ;move W to Xmit_Byte
                MOVLW   0x08                 ;set 8 bits out
                MOVWF   Bit_Cntr
                BSF     PORTB     , Ser_Out  ;send start bit
                CALL    Bit_Delay
Ser_Loop        RRF     Xmit_Byte , f        ;send one bit
                BTFSS   STATUS    , C
                BSF     PORTB     , Ser_Out
                BTFSC   STATUS    , C
                BCF     PORTB     , Ser_Out
                CALL    Bit_Delay
                DECFSZ  Bit_Cntr  , f        ;test if all done
                GOTO    Ser_Loop
                BCF     PORTB     , Ser_Out  ;and send stop bit
                CALL    Bit_Delay
                RETURN


Start_Delay     MOVLW   0x0C
                MOVWF   Delay_Count
Start_Wait      NOP
                DECFSZ  Delay_Count , f
                GOTO    Start_Wait
                RETURN

Bit_Delay       MOVLW   0x18
                MOVWF   Delay_Count
Bit_Wait        NOP
                DECFSZ  Delay_Count , f
                GOTO    Bit_Wait
                RETURN


S_Key	movlw	'S'
	movwf	Key
	return

F_Key	movlw	'F'
	movwf	Key
	return

B_Key	movlw	'B'
	movwf	Key
	return

L_Key	movlw	'L'
	movwf	Key
	return

R_Key	movlw	'R'
	movwf	Key
	return

Q_Key	movlw	0x00
	movwf	Key
	return

f_Key	movlw	'f'
	movwf	Key
	return

I_Key	movlw	'I'
	movwf	Key
	return

l_Key	movlw	'l'
	movwf	Key
	return

r_Key	movlw	'r'
	movwf	Key
	return

ChkKeys	btfss	PORTB, 6
	goto	I_Key
	btfss	PORTB, 5
	goto	F_Key
	btfss	PORTB, 4
	goto	B_Key
	btfss	PORTB, 3
	goto	L_Key
	btfss	PORTB, 2
	goto	R_Key
	btfss	PORTB, 1
	goto	Q_Key
;	btfss	PORTB, 0
;	goto	f_Key
;	btfss	PORTA, 4
;	goto	I_Key
	return


; End of subroutines

; Start of main program

; Define port directions (all A as inputs)
start	movlw 	0xFF
	; set bank 1
	bsf	STATUS, RP0
	movwf	TRISA
	movlw 	b'01111111'	;set B7 as output
	movwf	TRISB
	; set bank 0
	bcf	STATUS, RP0
	bcf     PORTB, Ser_Out	; set output low



MAIN	wait	1	; delay 1 second
	movlw	0x00
	movwf	Key	; set 0 (stop) as initial key.
Loop	movfw	Key
	movwf	Xmit_Byte
	call	Xmit_RS232
	wait2	20	; delay 20 bit times
	call	ChkKeys	; check if key pressed
	goto	Loop	; loop back to start and run for ever.




	END
